/*
 * BlimaFrame.java
 *
 * Created on 11. Juli 2006, 08:55
 */

package blima;

import aswtools.ASWTools;
import aswtools.FileTools;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.InputStream;
import java.util.Iterator;
import java.util.Locale;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.jdesktop.layout.GroupLayout;

/**
 * Hauptfenster
 * @author eeasw
 */
public class BlimaFrame extends javax.swing.JFrame
{
  /**
   * Liste der Teilnehmer
   */
  protected TListe m_tListe;
  
  /** Creates new form BlimaFrame */
  public BlimaFrame()
  {
    // MARK Zum Testen der Lokalisierung die folgende Zeile benutzen
//    Locale.setDefault(Locale.ENGLISH);
    m_tListe = new TListe();
    java.net.URL imgURL = ClassLoader.getSystemResource("blima/blindpent.gif");
    Image img = Toolkit.getDefaultToolkit().getImage(imgURL);
    setIconImage(img);
    int k = ASWTools.toInt(BlimaConfig.getProperty("partycount"));
    for (int i = 0; i < k; i++)
    {
      String s = "p" + ASWTools.toStr(i);
      m_tListe.addElement(new BlimaTeilnehmer(BlimaConfig.getProperty(s)));
    }
    initComponents();
    updateReportList();
    loadProjects();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents()
  {
    jPtabs = new javax.swing.JTabbedPane();
    jPanel1 = new javax.swing.JPanel();
    jSPteilnehmer = new javax.swing.JScrollPane();
    jLteilnehmer = new javax.swing.JList();
    jBTneu = new javax.swing.JButton();
    jBTedit = new javax.swing.JButton();
    jBTdelete = new javax.swing.JButton();
    jPanel2 = new javax.swing.JPanel();
    jCBProjektauswahl = new javax.swing.JComboBox();
    jCBTeilnehmerauswahl = new javax.swing.JComboBox();
    jBNewProject = new javax.swing.JButton();
    jBReportProject = new javax.swing.JButton();
    jSplitPane1 = new javax.swing.JSplitPane();
    jPanel5 = new javax.swing.JPanel();
    jLabel3 = new javax.swing.JLabel();
    jScrollPane1 = new javax.swing.JScrollPane();
    jTAEffekte = new javax.swing.JTextArea();
    jPanel6 = new javax.swing.JPanel();
    jLabel4 = new javax.swing.JLabel();
    jScrollPane3 = new javax.swing.JScrollPane();
    jTAAktionen = new javax.swing.JTextArea();
    jLabel5 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    jBSaveProject = new javax.swing.JButton();
    jLabel6 = new javax.swing.JLabel();
    jLabel9 = new javax.swing.JLabel();
    jScrollPane4 = new javax.swing.JScrollPane();
    jTAprojektbeschreibung = new javax.swing.JTextArea();
    jPanel3 = new javax.swing.JPanel();
    jCBBerichtauswahl = new javax.swing.JComboBox();
    jScrollPane2 = new javax.swing.JScrollPane();
    jTPaktuellerBericht = new javax.swing.JTextPane();
    jPanel4 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jtfDataFolder = new javax.swing.JTextField();
    jbChooseDataFolder = new javax.swing.JButton();
    jbChooseReportFolder = new javax.swing.JButton();
    jtfReportFolder = new javax.swing.JTextField();
    jLabel2 = new javax.swing.JLabel();
    jLabel7 = new javax.swing.JLabel();
    jtfProjectFolder = new javax.swing.JTextField();
    jBChooseProjectFolder = new javax.swing.JButton();
    jLabel10 = new javax.swing.JLabel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Blima");
    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosed(java.awt.event.WindowEvent evt)
      {
        formWindowClosed(evt);
      }
    });

    jLteilnehmer.setModel(m_tListe);
    jLteilnehmer.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jSPteilnehmer.setViewportView(jLteilnehmer);

    jBTneu.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butNew"));
    jBTneu.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBTneuActionPerformed(evt);
      }
    });

    jBTedit.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butEdit"));
    jBTedit.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBTeditActionPerformed(evt);
      }
    });

    jBTdelete.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butDelete"));
    jBTdelete.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBTdeleteActionPerformed(evt);
      }
    });

    org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
    jPanel1.setLayout(jPanel1Layout);
    jPanel1Layout.setHorizontalGroup(
      jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .add(jSPteilnehmer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
          .add(jBTedit, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .add(jBTneu, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .add(jBTdelete, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap())
    );
    jPanel1Layout.setVerticalGroup(
      jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel1Layout.createSequentialGroup()
        .addContainerGap()
        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
          .add(jSPteilnehmer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 374, Short.MAX_VALUE)
          .add(jPanel1Layout.createSequentialGroup()
            .add(jBTneu)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jBTedit)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jBTdelete)))
        .addContainerGap())
    );
    jPtabs.addTab(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("tabParticipant"), jPanel1);

    jCBProjektauswahl.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jCBProjektauswahlActionPerformed(evt);
      }
    });

    jCBTeilnehmerauswahl.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jCBTeilnehmerauswahlActionPerformed(evt);
      }
    });

    jBNewProject.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butNewProject"));
    jBNewProject.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBNewProjectActionPerformed(evt);
      }
    });

    jBReportProject.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butCloseProject"));
    jBReportProject.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBReportProjectActionPerformed(evt);
      }
    });

    jSplitPane1.setDividerLocation(230);
    jSplitPane1.setResizeWeight(0.5);
    jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel3.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("effects"));

    jTAEffekte.setColumns(20);
    jTAEffekte.setRows(5);
    jTAEffekte.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyTyped(java.awt.event.KeyEvent evt)
      {
        jTAEffekteKeyTyped(evt);
      }
    });

    jScrollPane1.setViewportView(jTAEffekte);

    org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
    jPanel5.setLayout(jPanel5Layout);
    jPanel5Layout.setHorizontalGroup(
      jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE)
      .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE)
    );
    jPanel5Layout.setVerticalGroup(
      jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel5Layout.createSequentialGroup()
        .add(jLabel3)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE))
    );
    jSplitPane1.setLeftComponent(jPanel5);

    jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel4.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("aktionen"));

    jTAAktionen.setColumns(20);
    jTAAktionen.setRows(5);
    jTAAktionen.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyTyped(java.awt.event.KeyEvent evt)
      {
        jTAAktionenKeyTyped(evt);
      }
    });

    jScrollPane3.setViewportView(jTAAktionen);

    org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
    jPanel6.setLayout(jPanel6Layout);
    jPanel6Layout.setHorizontalGroup(
      jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jLabel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE)
      .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE)
    );
    jPanel6Layout.setVerticalGroup(
      jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel6Layout.createSequentialGroup()
        .add(jLabel4)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE))
    );
    jSplitPane1.setRightComponent(jPanel6);

    jLabel5.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labChooseProject"));

    jLabel8.setBackground(new java.awt.Color(0, 0, 255));
    jLabel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

    jBSaveProject.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butSaveProject"));
    jBSaveProject.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBSaveProjectActionPerformed(evt);
      }
    });

    jLabel6.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labChooseParticipant"));

    jLabel9.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labProjectDescription"));

    jTAprojektbeschreibung.setColumns(20);
    jTAprojektbeschreibung.setRows(5);
    jTAprojektbeschreibung.addCaretListener(new javax.swing.event.CaretListener()
    {
      public void caretUpdate(javax.swing.event.CaretEvent evt)
      {
        jTAprojektbeschreibungCaretUpdate(evt);
      }
    });

    jScrollPane4.setViewportView(jTAprojektbeschreibung);

    org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
    jPanel2.setLayout(jPanel2Layout);
    jPanel2Layout.setHorizontalGroup(
      jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel2Layout.createSequentialGroup()
        .addContainerGap()
        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
          .add(jPanel2Layout.createSequentialGroup()
            .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
            .addContainerGap())
          .add(jPanel2Layout.createSequentialGroup()
            .add(jLabel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
            .addContainerGap())
          .add(jPanel2Layout.createSequentialGroup()
            .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
              .add(jLabel5)
              .add(jCBProjektauswahl, 0, 378, Short.MAX_VALUE))
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jBNewProject)
            .add(10, 10, 10))
          .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
            .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
              .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2Layout.createSequentialGroup()
                .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jCBTeilnehmerauswahl, 0, 337, Short.MAX_VALUE))
              .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2Layout.createSequentialGroup()
                .add(jBSaveProject)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jBReportProject)
                .add(235, 235, 235)))
            .addContainerGap())
          .add(jPanel2Layout.createSequentialGroup()
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jLabel9)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 383, Short.MAX_VALUE)
            .addContainerGap())))
    );
    jPanel2Layout.setVerticalGroup(
      jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel2Layout.createSequentialGroup()
        .addContainerGap()
        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
          .add(jBNewProject)
          .add(jPanel2Layout.createSequentialGroup()
            .add(jLabel5)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(jCBProjektauswahl, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jLabel8)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
          .add(jLabel9)
          .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
          .add(jBSaveProject)
          .add(jBReportProject))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
          .add(jLabel6)
          .add(jCBTeilnehmerauswahl, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
        .addContainerGap())
    );
    jPtabs.addTab(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("tabProjects"), jPanel2);

    jCBBerichtauswahl.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jCBBerichtauswahlActionPerformed(evt);
      }
    });

    jScrollPane2.setViewportView(jTPaktuellerBericht);

    org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
    jPanel3.setLayout(jPanel3Layout);
    jPanel3Layout.setHorizontalGroup(
      jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
        .addContainerGap()
        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
          .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
          .add(org.jdesktop.layout.GroupLayout.LEADING, jCBBerichtauswahl, 0, 485, Short.MAX_VALUE))
        .addContainerGap())
    );
    jPanel3Layout.setVerticalGroup(
      jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel3Layout.createSequentialGroup()
        .addContainerGap()
        .add(jCBBerichtauswahl, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 346, Short.MAX_VALUE)
        .addContainerGap())
    );
    jPtabs.addTab(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("tabReports"), jPanel3);

    jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
    jLabel1.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labDataFolder"));

    jtfDataFolder.setText(BlimaConfig.getProperty("dataFolder", "data"));

    jbChooseDataFolder.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose"));
    jbChooseDataFolder.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jbChooseDataFolderActionPerformed(evt);
      }
    });

    jbChooseReportFolder.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose"));
    jbChooseReportFolder.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jbChooseReportFolderActionPerformed(evt);
      }
    });

    jtfReportFolder.setText(BlimaConfig.getProperty("reportFolder", "report"));

    jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
    jLabel2.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labReportFolder"));

    jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
    jLabel7.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("labProjectFolder"));

    jtfProjectFolder.setText(BlimaConfig.getProperty("projectFolder", ""));

    jBChooseProjectFolder.setText(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose"));
    jBChooseProjectFolder.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jBChooseProjectFolderActionPerformed(evt);
      }
    });

    jLabel10.setText("blima@aswcode.de");

    org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
    jPanel4.setLayout(jPanel4Layout);
    jPanel4Layout.setHorizontalGroup(
      jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel4Layout.createSequentialGroup()
        .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
          .add(jPanel4Layout.createSequentialGroup()
            .add(10, 10, 10)
            .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
              .add(jtfReportFolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
              .add(jtfProjectFolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
              .add(jPanel4Layout.createSequentialGroup()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                  .add(jLabel1)
                  .add(jPanel4Layout.createSequentialGroup()
                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                    .add(jLabel2))
                  .add(jPanel4Layout.createSequentialGroup()
                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                    .add(jLabel7)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 348, Short.MAX_VALUE)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                  .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jbChooseDataFolder)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jbChooseReportFolder))
                  .add(jBChooseProjectFolder)))
              .add(jtfDataFolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)))
          .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel4Layout.createSequentialGroup()
            .addContainerGap(403, Short.MAX_VALUE)
            .add(jLabel10)))
        .addContainerGap())
    );
    jPanel4Layout.setVerticalGroup(
      jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPanel4Layout.createSequentialGroup()
        .addContainerGap()
        .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
          .add(jbChooseDataFolder)
          .add(jLabel1))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jtfDataFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
          .add(jbChooseReportFolder)
          .add(jLabel2))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jtfReportFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
          .add(jBChooseProjectFolder)
          .add(jLabel7))
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        .add(jtfProjectFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 201, Short.MAX_VALUE)
        .add(jLabel10)
        .addContainerGap())
    );
    jPtabs.addTab(java.util.ResourceBundle.getBundle("blima/BlimaText").getString("tabConfig"), jPanel4);

    org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPtabs, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 510, Short.MAX_VALUE)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
      .add(jPtabs, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE)
    );
    pack();
  }// </editor-fold>//GEN-END:initComponents

  private void jTAprojektbeschreibungCaretUpdate(javax.swing.event.CaretEvent evt)//GEN-FIRST:event_jTAprojektbeschreibungCaretUpdate
  {//GEN-HEADEREND:event_jTAprojektbeschreibungCaretUpdate
    // projektbeschreibung aktualisieren
    BlimaProjekt bp = (BlimaProjekt)jCBProjektauswahl.getSelectedItem();
    bp.setDescription(jTAprojektbeschreibung.getText());
    jBSaveProject.setEnabled(true);
  }//GEN-LAST:event_jTAprojektbeschreibungCaretUpdate

  private void jTAAktionenKeyTyped(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTAAktionenKeyTyped
  {//GEN-HEADEREND:event_jTAAktionenKeyTyped
    ProjektTeilnehmer pt = (ProjektTeilnehmer) jCBTeilnehmerauswahl.getSelectedItem();
    pt.aktion = jTAAktionen.getText();
    jBSaveProject.setEnabled(true);
  }//GEN-LAST:event_jTAAktionenKeyTyped

  private void jTAEffekteKeyTyped(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTAEffekteKeyTyped
  {//GEN-HEADEREND:event_jTAEffekteKeyTyped
    ProjektTeilnehmer pt = (ProjektTeilnehmer) jCBTeilnehmerauswahl.getSelectedItem();
    pt.effekt = jTAEffekte.getText();
    jBSaveProject.setEnabled(true);
  }//GEN-LAST:event_jTAEffekteKeyTyped
  
  /** Projekt abschlieen
   *
   * @param evt das event
   */
  private void jBReportProjectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBReportProjectActionPerformed
  {//GEN-HEADEREND:event_jBReportProjectActionPerformed
    // berprfen, ob alles ausgefllt ist
    BlimaProjekt bp = (BlimaProjekt)jCBProjektauswahl.getSelectedItem();
    if (!bp.checkDone())
    {
      String s = java.util.ResourceBundle.getBundle("blima/BlimaText").getString("NoCloseProject");
      JOptionPane.showMessageDialog(this, s, java.util.ResourceBundle.getBundle("blima/BlimaText").getString("warning"), 
              JOptionPane.ERROR_MESSAGE);
    }
    // ist das CSS file da?
    File css = new File(BlimaConfig.getProperty("reportFolder", "") + File.separator + "blima.css");
    if (!css.exists())
    {
      // aus den resourcen kopieren
      InputStream inst = ClassLoader.getSystemResourceAsStream("blima/blima.css");
      //File cssVorlage = new File("blima/blima.css");
      FileTools.copyResource(inst, BlimaConfig.getProperty("reportFolder", "")+ File.separator+"blima.css");
    }
    // report generieren und anzeigen
    String s = bp.createReport();
    File rep = new File(BlimaConfig.getProperty("reportFolder", "") + File.separator + bp.getName() + ".html");
    if (FileTools.saveAsFile(rep, s))
    {
      updateReportList();
      // projektdaten lschen
      bp.cleanup();
      loadProjects();
    }
  }//GEN-LAST:event_jBReportProjectActionPerformed
      
  private void jBSaveProjectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBSaveProjectActionPerformed
  {//GEN-HEADEREND:event_jBSaveProjectActionPerformed
    ((BlimaProjekt)jCBProjektauswahl.getSelectedItem()).speichern();
    jBSaveProject.setEnabled(false);
  }//GEN-LAST:event_jBSaveProjectActionPerformed
  
  private void jCBTeilnehmerauswahlActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jCBTeilnehmerauswahlActionPerformed
  {//GEN-HEADEREND:event_jCBTeilnehmerauswahlActionPerformed
    // Effekte und Aktionen des Teilnehmers anzeigen
    ProjektTeilnehmer pt = (ProjektTeilnehmer)jCBTeilnehmerauswahl.getSelectedItem();
    if (pt == null) return;
    boolean b = jBSaveProject.isEnabled();
    jTAEffekte.setText(pt.effekt);
    jTAAktionen.setText(pt.aktion);
    jBSaveProject.setEnabled(b);
  }//GEN-LAST:event_jCBTeilnehmerauswahlActionPerformed
  
  /**
   * Einen Projektordner whlen
   * @param evt das Event
   */
  private void jBChooseProjectFolderActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBChooseProjectFolderActionPerformed
  {//GEN-HEADEREND:event_jBChooseProjectFolderActionPerformed
    JFileChooser fc = new JFileChooser();
    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    fc.setCurrentDirectory(new File(BlimaConfig.getInstance().getProperty("projectFolder")));
    String txt = java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose");
    if (fc.showDialog(this, txt) == JFileChooser.APPROVE_OPTION)
    {
      BlimaConfig.getInstance().setProperty("projectFolder", fc.getSelectedFile().getPath());
      updateConfig();
      loadProjects();
    }
  }//GEN-LAST:event_jBChooseProjectFolderActionPerformed
  
  /**
   * Neues Projekt anlegen
   * @param evt das event
   */
  private void jBNewProjectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBNewProjectActionPerformed
  {//GEN-HEADEREND:event_jBNewProjectActionPerformed
    // nach dem Namen fragen
    String s = java.util.ResourceBundle.getBundle("blima/BlimaText").getString("askProjectName");
    s = JOptionPane.showInputDialog(this, s);
    if (s == null) return;
    // anlegen
    BlimaProjekt bp = new BlimaProjekt(s);
    //Vector v = bp.getLeute();
    for (int i = 0; i < m_tListe.getSize(); i++)
      //v.addElement(m_tListe.getElementAt(i));
      bp.addTeilnehmer(m_tListe.getElementAt(i));
    bp.mischen();
    bp.speichern();
    jCBProjektauswahl.addItem(bp);
    jCBProjektauswahl.setSelectedItem(bp);
  }//GEN-LAST:event_jBNewProjectActionPerformed
  
  /**
   * Anderes Projekt auswhlen
   * @param evt das Event
   */
  private void jCBProjektauswahlActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jCBProjektauswahlActionPerformed
  {//GEN-HEADEREND:event_jCBProjektauswahlActionPerformed
    // ausgewhltes Projekt anzeigen
    Object o = jCBProjektauswahl.getSelectedItem();
    if (o instanceof BlimaProjekt)
    {
      BlimaProjekt bp = (BlimaProjekt)o;
      jTAprojektbeschreibung.setText(bp.getDescription());
      // Teilnehmer fllen
      jCBTeilnehmerauswahl.removeAllItems();
      Vector v = bp.getLeute();
      for(int i = 0; i < v.size(); i++) jCBTeilnehmerauswahl.addItem(v.elementAt(i));
      // ersten Teilnehmer anzeigen
      jCBTeilnehmerauswahl.setSelectedIndex(0);
      jBSaveProject.setEnabled(false);
    }
    
  }//GEN-LAST:event_jCBProjektauswahlActionPerformed
  
  /**
   * neuen Bericht gewhlt
   * @param evt das Event
   */
  private void jCBBerichtauswahlActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jCBBerichtauswahlActionPerformed
  {//GEN-HEADEREND:event_jCBBerichtauswahlActionPerformed
    // ausgewhlten Bericht anzeigen
    Object o = jCBBerichtauswahl.getSelectedItem();
    if (o instanceof File)
    {
      File f = (File)o;
      try
      {
        jTPaktuellerBericht.setPage(f.toURL());
      }
      catch (java.io.IOException e)
      {
        jTPaktuellerBericht.setText(e.getLocalizedMessage());
      }
//      catch (java.net.MalformedURLException e1)
//      {
//        jTPaktuellerBericht.setText(e1.getLocalizedMessage());
//      }
    }
  }//GEN-LAST:event_jCBBerichtauswahlActionPerformed
  
  /**
   * Teilnehmer lschen
   * @param evt das event
   */
  private void jBTdeleteActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBTdeleteActionPerformed
  {//GEN-HEADEREND:event_jBTdeleteActionPerformed
    int k = jLteilnehmer.getSelectedIndex();
    m_tListe.removeElementAt(k);
    updateConfig();
  }//GEN-LAST:event_jBTdeleteActionPerformed
  
  private void jbChooseReportFolderActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jbChooseReportFolderActionPerformed
  {//GEN-HEADEREND:event_jbChooseReportFolderActionPerformed
    JFileChooser fc = new JFileChooser();
    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    fc.setCurrentDirectory(new File(BlimaConfig.getInstance().getProperty("reportFolder")));
    String txt = java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose");
    if (fc.showDialog(this, txt) == JFileChooser.APPROVE_OPTION)
    {
      BlimaConfig.getInstance().setProperty("reportFolder", fc.getSelectedFile().getPath());
      updateConfig();
    }
  }//GEN-LAST:event_jbChooseReportFolderActionPerformed
  
  private void formWindowClosed(java.awt.event.WindowEvent evt)//GEN-FIRST:event_formWindowClosed
  {//GEN-HEADEREND:event_formWindowClosed
    BlimaConfig.getInstance().saveProperties();
    System.exit(0);
  }//GEN-LAST:event_formWindowClosed
  
  private void jBTeditActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBTeditActionPerformed
  {//GEN-HEADEREND:event_jBTeditActionPerformed
    BlimaTeilnehmer bt = (BlimaTeilnehmer)jLteilnehmer.getSelectedValue();
    TeilnehmerEditForm tef = new TeilnehmerEditForm(bt);
    tef.setModal(true);
    tef.setVisible(true);
    if (tef.isDone())
    {
      BlimaTeilnehmer bu = tef.getBlimaTeilnehmer();
      bt.setFile(bu.getFile());
      bt.setName(bu.getName());
      updateConfig();
    }
    
  }//GEN-LAST:event_jBTeditActionPerformed
  
  /**
   * Neuen Datenordner whlen
   * @param evt das event
   */
  private void jbChooseDataFolderActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jbChooseDataFolderActionPerformed
  {//GEN-HEADEREND:event_jbChooseDataFolderActionPerformed
    JFileChooser fc = new JFileChooser();
    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    fc.setCurrentDirectory(new File(BlimaConfig.getInstance().getProperty("dataFolder")));
    String txt = java.util.ResourceBundle.getBundle("blima/BlimaText").getString("butChoose");
    if (fc.showDialog(this, txt) == JFileChooser.APPROVE_OPTION)
    {
      BlimaConfig.getInstance().setProperty("dataFolder", fc.getSelectedFile().getPath());
      updateConfig();
    }
  }//GEN-LAST:event_jbChooseDataFolderActionPerformed
  
  /** neuen Teilnehmer anlegen
   * TODO Teilnehmernamen drfen nicht doppelt sein
   *
   * @param evt startevent
   */
  private void jBTneuActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jBTneuActionPerformed
  {//GEN-HEADEREND:event_jBTneuActionPerformed
    BlimaTeilnehmer bt = new BlimaTeilnehmer("", System.getProperty("user.home"));
    TeilnehmerEditForm tef = new TeilnehmerEditForm(bt);
    tef.setModal(true);
    tef.setVisible(true);
    if (tef.isDone())
    {
      m_tListe.addElement(tef.getBlimaTeilnehmer());
      updateConfig();
    }
  }//GEN-LAST:event_jBTneuActionPerformed
  
  /**
   * main
   * @param args the command line arguments
   */
  public static void main(String args[])
  {
    java.awt.EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new BlimaFrame().setVisible(true);
      }
    });
  }
  
  private void updateConfig()
  {
    jtfDataFolder.setText(BlimaConfig.getProperty("dataFolder"));
    jtfReportFolder.setText(BlimaConfig.getProperty("reportFolder"));
    jtfProjectFolder.setText(BlimaConfig.getProperty("projectFolder"));
    BlimaConfig.setProperty("partycount", ASWTools.toStr(m_tListe.getSize()));
    for (int i = 0; i < m_tListe.getSize(); i++)
    {
      String s = "p" + ASWTools.toStr(i);
      BlimaConfig.setProperty(s, m_tListe.getElementAt(i).toSaveString());
    }
  }
  
  private void updateReportList()
  {
    jCBBerichtauswahl.removeAllItems();
    //jetzt die reportliste fllen: alle html im reportordner
    File rep = new File(BlimaConfig.getProperty("reportFolder"));
    File[] lst = rep.listFiles();
    if (lst != null)
    {
      for (int i = 0; i < lst.length; i++)
      {
        if (lst[i].isFile())
          if (lst[i].getName().endsWith(".html") || lst[i].getName().endsWith(".htm"))
            jCBBerichtauswahl.addItem(lst[i]);
      }
    }
  }
  
  private void loadProjects()
  {
    // alle projektdateien suchen
    Vector v = FileTools.findAll(".blp", new File(BlimaConfig.getProperty("projectFolder")));
    jCBProjektauswahl.removeAllItems();
    for (Iterator it = v.iterator(); it.hasNext();)
    {
      File elem = (File) it.next();
      jCBProjektauswahl.addItem(new BlimaProjekt(elem));
    }
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jBChooseProjectFolder;
  private javax.swing.JButton jBNewProject;
  private javax.swing.JButton jBReportProject;
  private javax.swing.JButton jBSaveProject;
  private javax.swing.JButton jBTdelete;
  private javax.swing.JButton jBTedit;
  private javax.swing.JButton jBTneu;
  private javax.swing.JComboBox jCBBerichtauswahl;
  private javax.swing.JComboBox jCBProjektauswahl;
  private javax.swing.JComboBox jCBTeilnehmerauswahl;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel10;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JLabel jLabel7;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JList jLteilnehmer;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JTabbedPane jPtabs;
  private javax.swing.JScrollPane jSPteilnehmer;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JScrollPane jScrollPane3;
  private javax.swing.JScrollPane jScrollPane4;
  private javax.swing.JSplitPane jSplitPane1;
  private javax.swing.JTextArea jTAAktionen;
  private javax.swing.JTextArea jTAEffekte;
  private javax.swing.JTextArea jTAprojektbeschreibung;
  private javax.swing.JTextPane jTPaktuellerBericht;
  private javax.swing.JButton jbChooseDataFolder;
  private javax.swing.JButton jbChooseReportFolder;
  private javax.swing.JTextField jtfDataFolder;
  private javax.swing.JTextField jtfProjectFolder;
  private javax.swing.JTextField jtfReportFolder;
  // End of variables declaration//GEN-END:variables
  
}
