/*
 * BlimaTeilnehmer.java
 *
 * Created on 11. Juli 2006, 10:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package blima;

import java.io.File;

/**
 * Klasse zur Beschreibung eines Teilnehmers, Listendarstellung
 * @author eeasw
 */
public class BlimaTeilnehmer
{
  /**
   * Name des Teilnehmers
   */
  private String name;
  /**
   * zugehrige Datei, z.B. Seine Sigille
   */
  private String datei;
  
  /**
   * Creates a new instance of BlimaTeilnehmer
   * @param savestring name; file as created by toString()
   */
  public BlimaTeilnehmer(String savestring)
  {
    int k = savestring.indexOf("; ");
    if (k > -1)
    {
      name = savestring.substring(0, k);
      datei = savestring.substring(k+2);
    }else{
      name = "keiner";
      datei = "";
    }
  }
  /**
   * Creates a new instance of BlimaTeilnehmer
   * @param theName name of the participant
   * @param theFile name of the file (stored in the data folder
   */
  public BlimaTeilnehmer(String theName, String theFile)
  {
    name = theName;
    datei = theFile;
  }
  
  /**
   * makes name; file
   * @return name; file
   */
  public String toSaveString()
  {
    return name + "; " + datei;
  }
  
  /**
   * anzeigestring
   * @return name
   */
  public String toString()
  {
    return name;
  }
  
  /**
   * getter
   * @return nur den Dateinamen
   */
  public String getFile()
  {
    return datei;
  }
  /**
   * getter
   * @return datei mit pfad
   */
  public String getFullFile()
  {
    return BlimaConfig.getProperty("dataFolder", "data") + File.separator + datei;
  }
  
  /**
   * getter
   * @return name des teilnehmers
   */
  public String getName()
  {
    return name;
  }
  /**
   * dateinamen setzen
   * @param n dateiname
   */
  public void setFile( String n )
  {
    datei = n;
  }
  /**
   * setter
   * @param n teilnehmername
   */
  public void setName( String n )
  {
    name = n;
  }
}
